/*
 * Copyright (c) 2019 NIBIO <http://www.nibio.no/>. 
 * 
 * This file is part of SeptoriaReferenceHumidityModel.
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 * 
 */

package no.nibio.vips.model.septoriareferencehumiditymodel;

import java.util.List;
import no.nibio.vips.entity.ModelConfiguration;
import no.nibio.vips.entity.Result;
import no.nibio.vips.model.ModelId;
import no.nibio.vips.util.test.WeatherDataFileReader;
import org.junit.jupiter.api.AfterEach;
import org.junit.jupiter.api.AfterAll;
import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.BeforeAll;
import org.junit.jupiter.api.Test;
import static org.junit.jupiter.api.Assertions.*;

/**
 *
 * @author Tor-Einar Skog <tor-einar.skog@nibio.no>
 */
public class SeptoriaReferenceHumidityModelTest {
    
    public SeptoriaReferenceHumidityModelTest() {
    }
    
    @BeforeAll
    public static void setUpClass() {
    }
    
    @AfterAll
    public static void tearDownClass() {
    }
    
    @BeforeEach
    public void setUp() {
    }
    
    @AfterEach
    public void tearDown() {
    }

    /**
     * Test of getResult method, of class SeptoriaReferenceHumidityModel.
     */
    @org.junit.jupiter.api.Test
    public void testGetResult() throws Exception {
        System.out.println("getResult");
        ModelConfiguration config = new WeatherDataFileReader().getModelConfigurationWithWeatherData("/ullensvang.json", SeptoriaReferenceHumidityModel.MODEL_ID.toString());
        config.setConfigParameter("timeZone", "Europe/Oslo");
        SeptoriaReferenceHumidityModel instance = new SeptoriaReferenceHumidityModel();
        instance.setConfiguration(config);
        //System.out.println(config.toJSON());

        List<Result> result = instance.getResult();
        //result.forEach(r->System.out.println(r.toString()));
        assertNotNull(result);
        
    }

    /**
     * Test of getModelId method, of class SeptoriaReferenceHumidityModel.
     */
    //@org.junit.jupiter.api.Test
    public void testGetModelId() {
        System.out.println("getModelId");
        SeptoriaReferenceHumidityModel instance = new SeptoriaReferenceHumidityModel();
        ModelId result = instance.getModelId();
        assertEquals(result, SeptoriaReferenceHumidityModel.MODEL_ID); 
        
    }

    /**
     * Test of getModelName method, of class SeptoriaReferenceHumidityModel.
     */
    //@org.junit.jupiter.api.Test
    public void testGetModelName_0args() {
        System.out.println("getModelName");
        SeptoriaReferenceHumidityModel instance = new SeptoriaReferenceHumidityModel();
        String result = instance.getModelName();
        assertNotNull(result);
        assertTrue(!result.isBlank());
    }

    /**
     * Test of getModelName method, of class SeptoriaReferenceHumidityModel.
     */
    //@org.junit.jupiter.api.Test
    public void testGetModelName_String() {
        System.out.println("getModelName");
        String language = "";
        SeptoriaReferenceHumidityModel instance = new SeptoriaReferenceHumidityModel();
        String result = instance.getModelName(language);
        assertNotNull(result);
        
    }

    /**
     * Test of getLicense method, of class SeptoriaReferenceHumidityModel.
     */
    //@org.junit.jupiter.api.Test
    public void testGetLicense() {
        System.out.println("getLicense");
        SeptoriaReferenceHumidityModel instance = new SeptoriaReferenceHumidityModel();
        String result = instance.getLicense();
        assertNotNull(result);
    }

    /**
     * Test of getCopyright method, of class SeptoriaReferenceHumidityModel.
     */
    //@org.junit.jupiter.api.Test
    public void testGetCopyright() {
        System.out.println("getCopyright");
        SeptoriaReferenceHumidityModel instance = new SeptoriaReferenceHumidityModel();
        String result = instance.getCopyright();
        assertNotNull(result);
    }

    /**
     * Test of getModelDescription method, of class SeptoriaReferenceHumidityModel.
     */
    //@org.junit.jupiter.api.Test
    public void testGetModelDescription_0args() {
        System.out.println("getModelDescription");
        SeptoriaReferenceHumidityModel instance = new SeptoriaReferenceHumidityModel();
        String result = instance.getModelDescription();
        assertNotNull(result);
    }

    /**
     * Test of getModelDescription method, of class SeptoriaReferenceHumidityModel.
     */
    //@org.junit.jupiter.api.Test
    public void testGetModelDescription_String() {
        System.out.println("getModelDescription");
        String language = "";
        SeptoriaReferenceHumidityModel instance = new SeptoriaReferenceHumidityModel();
        String result = instance.getModelDescription(language);
        assertNotNull(result);
    }

    /**
     * Test of getWarningStatusInterpretation method, of class SeptoriaReferenceHumidityModel.
     */
    //@org.junit.jupiter.api.Test
    public void testGetWarningStatusInterpretation_0args() {
        System.out.println("getWarningStatusInterpretation");
        SeptoriaReferenceHumidityModel instance = new SeptoriaReferenceHumidityModel();
        String result = instance.getWarningStatusInterpretation();
        assertNotNull(result);
    }

    /**
     * Test of getWarningStatusInterpretation method, of class SeptoriaReferenceHumidityModel.
     */
    //@org.junit.jupiter.api.Test
    public void testGetWarningStatusInterpretation_String() {
        System.out.println("getWarningStatusInterpretation");
        String language = "";
        SeptoriaReferenceHumidityModel instance = new SeptoriaReferenceHumidityModel();
        String result = instance.getWarningStatusInterpretation(language);
        assertNotNull(result);
    }

    /**
     * Test of getModelUsage method, of class SeptoriaReferenceHumidityModel.
     */
    //@org.junit.jupiter.api.Test
    public void testGetModelUsage_0args() {
        System.out.println("getModelUsage");
        SeptoriaReferenceHumidityModel instance = new SeptoriaReferenceHumidityModel();
        String result = instance.getModelUsage();
        assertNotNull(result);
    }

    /**
     * Test of getModelUsage method, of class SeptoriaReferenceHumidityModel.
     */
    //@org.junit.jupiter.api.Test
    public void testGetModelUsage_String() {
        System.out.println("getModelUsage");
        String language = "";
        SeptoriaReferenceHumidityModel instance = new SeptoriaReferenceHumidityModel();
        String result = instance.getModelUsage(language);
        assertNotNull(result);
    }

    /**
     * Test of getSampleConfig method, of class SeptoriaReferenceHumidityModel.
     */
    //@org.junit.jupiter.api.Test
    public void testGetSampleConfig() {
        System.out.println("getSampleConfig");
        SeptoriaReferenceHumidityModel instance = new SeptoriaReferenceHumidityModel();
        String result = instance.getSampleConfig();
        assertNotNull(result);
    }

}
